//Sendet den Lenkzustand zurück an den PC:
// X==-1 Y==1  Z==0

//Verwendet ein Neuronales Netz
//auf Grundlage von:
//   AV601_integer_Neuro

//MAXWERT=16129 MINWERT=-3575  .... deshalb 2-Byte-Integer o.k.

int sensor=0;
int lenk = 0;

char w[] = {-77,-77,127,-23,73,-127,23,-27,73,-27,-23,-127,23,-27,-127,-27,23,-27,127,-73};

//für Input -127..+127, also 255 verschiedene Werte:
char sigmo[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,15,34,63,92,111,120,124,126,126,126,126,126,126,126,126,126,126,126,126,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127};
int s0,s1,s2,s3,   out0,out1,out2,out3,out4;
int sens0,sens1,sens2,sens3;
int sigmoid(int x)
{
   if(x<-127) x=-127;
   if(x> 127) x=127;
   x+=127;
   return sigmo[x];
}

int neuro(int s0, int s1,int s2, int s3)
{
    out0=s0*w[0]+s1*w[1]+s2*w[2]+s3*w[3];
    out1=s0*w[4]+s1*w[5]+s2*w[6]+s3*w[7];
    out2=s0*w[8]+s1*w[9]+s2*w[10]+s3*w[11];
    out3=s0*w[12]+s1*w[13]+s2*w[14]+s3*w[15];

//    out0 = sigmoid(out0);
//    out1 = sigmoid(out1);
//    out2 = sigmoid(out2);
//    out3 = sigmoid(out3);

    out4 = out0*w[16]+out1*w[17]+out2*w[18]+out3*w[19];

//    out4 = sigmoid(out4);

    if(out4>32)        
        return 1;
    else if(out4<-32)        
        return -1;
    else
        return 0;    
        

//    out4 = (out4 - 63)/63;

//    return out4;
}

void setup() 
{
    Serial.begin(9600);

    pinMode(9,OUTPUT);
    pinMode(10,OUTPUT);
    pinMode(11,OUTPUT);
    pinMode(12,OUTPUT);

    digitalWrite(9,LOW);
    digitalWrite(10,LOW);
    digitalWrite(11,LOW);
    digitalWrite(12,LOW);
}

void loop() 
{
    while(Serial.available())
    {
        sensor = Serial.read();
    }

    if(sensor>='A' && sensor<='A'+15)
    {
        sensor-='A';

        //Regeln wie in regel() ... einfache Version im Processing Sketch
//Processing:        
//      public float regeln(int[] sensorwerte) //liefert omega
//     {
//         if(sensorwerte[2]==0)
//            return -1;
//         else if(sensorwerte[3]==0)
//            return 1;
//         else
//            return 0.0;
//      }

//Hier: DEAKTIVERT

//        if((sensor/4)%2==0)  //s2
//            lenk = -1;
//        else if((sensor/8)%2==0) //s3
//            lenk =  1;
//        else
//            lenk = 0;    

//Neuronales Netz:
        if((sensor/1)%2==0)
            sens0=0;
        else
            sens0=1;    

        if((sensor/2)%2==0)
            sens1=0;
        else
            sens1=1;    

        if((sensor/4)%2==0)
            sens2=0;
        else
            sens2=1;    

        if((sensor/8)%2==0)
            sens3=0;
        else
            sens3=1;    

        lenk = neuro(sens0,sens1,sens2,sens3);

        //Zurück schicken:
        if(lenk==-1)
            Serial.write('X');
        else if(lenk==1)
            Serial.write('Y');
        else
            Serial.write('Z');

        // S0
        if(sensor%2>0) 
            digitalWrite(9,HIGH);
        else  
            digitalWrite(9,LOW);
        sensor/=2;
        // S1
        if(sensor%2>0) 
            digitalWrite(10,HIGH);
        else  
            digitalWrite(10,LOW);
        sensor/=2;
        // S2
        if(sensor%2>0) 
            digitalWrite(11,HIGH);
        else  
            digitalWrite(11,LOW);
        sensor/=2;
        // S3
        if(sensor%2>0) 
            digitalWrite(12,HIGH);
        else  
            digitalWrite(12,LOW);
         
    }
}
